package cn.com.ctop.kuaishou.modules.report.service.impl;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.HttpUtils;
import cn.com.ctop.common.module.utils.KuaishouInterfaceConstant;
import cn.com.ctop.common.module.utils.PropertiesUtils;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaiShouCreative;
import cn.com.ctop.kuaishou.modules.report.entity.KuaishouReportDailyImage;
import cn.com.ctop.kuaishou.modules.report.mapper.KuaishouReportDailyImageMapper;
import cn.com.ctop.kuaishou.modules.report.service.IKuaishouReportDailyImageService;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 快手图片报表
 * @author jeecg-boot
 * @date   2020-09-28
 * @version V1.0
 */
@Slf4j
@Service
public class KuaishouReportDailyImageServiceImpl extends ServiceImpl<KuaishouReportDailyImageMapper, KuaishouReportDailyImage> implements IKuaishouReportDailyImageService {

    @Override
    public void getMaterialImageReport(Long accountId, String accessToken, String startDate, String endDate, Integer page) {

        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", " application/json");
        headers.put("Access-Token", accessToken);

        JSONObject param = new JSONObject();
        param.put("advertiser_id", accountId);
        param.put("page_size", 2000);
        param.put("page", page);

        JSONObject resultJson = JSONObject.parseObject(HttpUtils.kuaiShouhttpPostRequest("https://ad.e.kuaishou.com/rest/openapi/v1/report/campaign_report", param.toJSONString(), headers));
        if (Check.isNull(resultJson)) {
            log.error("获取广告创意返回结果为空,advertiserId:{}", accountId);
            return;
        }
        Integer code = resultJson.getInteger("code");
        if (null == code || code != 0) {
            log.error("获取广告创意返回结果异常,advertiserId:{},message:{}", accountId, resultJson.getString("message"));
            return;
        }
        JSONArray details = resultJson.getJSONObject("data").getJSONArray("details");
        if (null == details || details.size() <= 0) {
            return;
        }
        List<KuaishouReportDailyImage> imageReports = new ArrayList<>();
        details.forEach(detail->{
            JSONObject detailJSON = (JSONObject) detail;
            if (!Check.isNull(detailJSON)) {
                KuaishouReportDailyImage kuaishouReportDailyImage =new KuaishouReportDailyImage();
            }
        });
    }

}
